/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * OpenAPI spec version: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { IoArgoprojEventsV1alpha1EventSourceFilter } from '../models/IoArgoprojEventsV1alpha1EventSourceFilter';
import { IoArgoprojEventsV1alpha1WatchPathConfig } from '../models/IoArgoprojEventsV1alpha1WatchPathConfig';
import { IoK8sApiCoreV1ConfigMapKeySelector } from '../models/IoK8sApiCoreV1ConfigMapKeySelector';
import { IoK8sApiCoreV1SecretKeySelector } from '../models/IoK8sApiCoreV1SecretKeySelector';
import { HttpFile } from '../http/http';

export class IoArgoprojEventsV1alpha1HDFSEventSource {
    'addresses'?: Array<string>;
    'checkInterval'?: string;
    'filter'?: IoArgoprojEventsV1alpha1EventSourceFilter;
    /**
    * HDFSUser is the user to access HDFS file system. It is ignored if either ccache or keytab is used.
    */
    'hdfsUser'?: string;
    'krbCCacheSecret'?: IoK8sApiCoreV1SecretKeySelector;
    'krbConfigConfigMap'?: IoK8sApiCoreV1ConfigMapKeySelector;
    'krbKeytabSecret'?: IoK8sApiCoreV1SecretKeySelector;
    /**
    * KrbRealm is the Kerberos realm used with Kerberos keytab It must be set if keytab is used.
    */
    'krbRealm'?: string;
    /**
    * KrbServicePrincipalName is the principal name of Kerberos service It must be set if either ccache or keytab is used.
    */
    'krbServicePrincipalName'?: string;
    /**
    * KrbUsername is the Kerberos username used with Kerberos keytab It must be set if keytab is used.
    */
    'krbUsername'?: string;
    'metadata'?: { [key: string]: string; };
    'type'?: string;
    'watchPathConfig'?: IoArgoprojEventsV1alpha1WatchPathConfig;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "addresses",
            "baseName": "addresses",
            "type": "Array<string>",
            "format": ""
        },
        {
            "name": "checkInterval",
            "baseName": "checkInterval",
            "type": "string",
            "format": ""
        },
        {
            "name": "filter",
            "baseName": "filter",
            "type": "IoArgoprojEventsV1alpha1EventSourceFilter",
            "format": ""
        },
        {
            "name": "hdfsUser",
            "baseName": "hdfsUser",
            "type": "string",
            "format": ""
        },
        {
            "name": "krbCCacheSecret",
            "baseName": "krbCCacheSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector",
            "format": ""
        },
        {
            "name": "krbConfigConfigMap",
            "baseName": "krbConfigConfigMap",
            "type": "IoK8sApiCoreV1ConfigMapKeySelector",
            "format": ""
        },
        {
            "name": "krbKeytabSecret",
            "baseName": "krbKeytabSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector",
            "format": ""
        },
        {
            "name": "krbRealm",
            "baseName": "krbRealm",
            "type": "string",
            "format": ""
        },
        {
            "name": "krbServicePrincipalName",
            "baseName": "krbServicePrincipalName",
            "type": "string",
            "format": ""
        },
        {
            "name": "krbUsername",
            "baseName": "krbUsername",
            "type": "string",
            "format": ""
        },
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "{ [key: string]: string; }",
            "format": ""
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "string",
            "format": ""
        },
        {
            "name": "watchPathConfig",
            "baseName": "watchPathConfig",
            "type": "IoArgoprojEventsV1alpha1WatchPathConfig",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojEventsV1alpha1HDFSEventSource.attributeTypeMap;
    }

    public constructor() {
    }
}

