/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * OpenAPI spec version: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { IoK8sApiCoreV1ConfigMapKeySelector } from '../models/IoK8sApiCoreV1ConfigMapKeySelector';
import { IoK8sApiCoreV1SecretKeySelector } from '../models/IoK8sApiCoreV1SecretKeySelector';
import { HttpFile } from '../http/http';

/**
* HDFSArtifactRepository defines the controller configuration for an HDFS artifact repository
*/
export class IoArgoprojWorkflowV1alpha1HDFSArtifactRepository {
    /**
    * Addresses is accessible addresses of HDFS name nodes
    */
    'addresses'?: Array<string>;
    /**
    * Force copies a file forcibly even if it exists
    */
    'force'?: boolean;
    /**
    * HDFSUser is the user to access HDFS file system. It is ignored if either ccache or keytab is used.
    */
    'hdfsUser'?: string;
    'krbCCacheSecret'?: IoK8sApiCoreV1SecretKeySelector;
    'krbConfigConfigMap'?: IoK8sApiCoreV1ConfigMapKeySelector;
    'krbKeytabSecret'?: IoK8sApiCoreV1SecretKeySelector;
    /**
    * KrbRealm is the Kerberos realm used with Kerberos keytab It must be set if keytab is used.
    */
    'krbRealm'?: string;
    /**
    * KrbServicePrincipalName is the principal name of Kerberos service It must be set if either ccache or keytab is used.
    */
    'krbServicePrincipalName'?: string;
    /**
    * KrbUsername is the Kerberos username used with Kerberos keytab It must be set if keytab is used.
    */
    'krbUsername'?: string;
    /**
    * PathFormat is defines the format of path to store a file. Can reference workflow variables
    */
    'pathFormat'?: string;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "addresses",
            "baseName": "addresses",
            "type": "Array<string>",
            "format": ""
        },
        {
            "name": "force",
            "baseName": "force",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "hdfsUser",
            "baseName": "hdfsUser",
            "type": "string",
            "format": ""
        },
        {
            "name": "krbCCacheSecret",
            "baseName": "krbCCacheSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector",
            "format": ""
        },
        {
            "name": "krbConfigConfigMap",
            "baseName": "krbConfigConfigMap",
            "type": "IoK8sApiCoreV1ConfigMapKeySelector",
            "format": ""
        },
        {
            "name": "krbKeytabSecret",
            "baseName": "krbKeytabSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector",
            "format": ""
        },
        {
            "name": "krbRealm",
            "baseName": "krbRealm",
            "type": "string",
            "format": ""
        },
        {
            "name": "krbServicePrincipalName",
            "baseName": "krbServicePrincipalName",
            "type": "string",
            "format": ""
        },
        {
            "name": "krbUsername",
            "baseName": "krbUsername",
            "type": "string",
            "format": ""
        },
        {
            "name": "pathFormat",
            "baseName": "pathFormat",
            "type": "string",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojWorkflowV1alpha1HDFSArtifactRepository.attributeTypeMap;
    }

    public constructor() {
    }
}

